<template>
  <div class="flex flex-col gap-2">
    <div>
      <div class="flex justify-center max-w-[14rem] m-auto">
        <div class="relative flex w-full p-1 bg-white dark:bg-slate-900 rounded-full">
          <span class="absolute inset-0 m-1 pointer-events-none" aria-hidden="true">
            <span
              class="absolute inset-0 w-1/2 bg-brand-500 rounded-full shadow-sm shadow-indigo-950/10 transform transition-transform duration-150 ease-in-out"
              :class="{ 'translate-x-full': monthlyPayment }"
            />
          </span>
          <button
            type="button"
            class="relative flex-1 text-sm font-medium h-8 rounded-full focus-visible:outline-none focus-visible:ring focus-visible:ring-indigo-300 transition-colors duration-150 ease-in-out"
            :class="{ 'bg-brand-500 text-white': !monthlyPayment }"
            @click="monthlyPayment = false"
          >
            Yearly
          </button>
          <button
            type="button"
            :class="{ 'bg-brand-500 text-white': monthlyPayment }"
            class="relative flex-1 text-sm font-medium h-8 rounded-full focus-visible:outline-none focus-visible:ring focus-visible:ring-indigo-300 transition-colors duration-150 ease-in-out"
            @click="monthlyPayment = true"
          >
            Monthly
          </button>
        </div>
      </div>
    </div>
    <div class="flex flex-wrap justify-center mb-8 sm:block">
      <div
        v-for="plan in plansList"
        :key="plan.key"
        class="flex flex-col basis-1/3 p-2"
      >
        <!-- Pricing plan block -->
        <div
          class="pricing-plan"
          :class="{
            active: plan.key === activePlan,
          }"
        >
          <div>
            <div class="flex flex-col">
              <div
                class="flex flex-wrap justify-between items-center gap-2  mb-3.5"
              >
                <!-- Title -->
                <h6 class="text-gray-900 text-base">
                  {{ plan.title }}
                </h6>
                <!-- Badge -->
                <span
                  v-if="getBadge(plan.key)"
                  class="h-5 rounded-full text-2xs font-medium px-2 flex items-center"
                  :class="getBadge(plan.key).class"
                >{{ getBadge(plan.key).content }}</span>
              </div>
              <!-- Description -->
              <div class="text-gray-600 text-2xs mb-4">
                {{ plan.description }}
              </div>
              <!-- Price -->
              <div class="flex items-start gap-1">
                <span class="text-brand-500 text-base">{{ !monthlyPayment ? plan.price : (plan.priceMonthly ?? plan.price) }}</span>
                <span class="text-2xs text-gray-400 font-medium" />
              </div>

              <el-button
                v-if="plan.ctaLabel[activePlan ?? Plans.values.none]"
                class="btn btn--md btn--full btn--primary mt-6"
                @click="() => handleOnCtaClick(plan)"
              >
                {{ plan.ctaLabel[activePlan ?? Plans.values.none] ?? `Subscribe to ${plan.title}` }}
              </el-button>
            </div>

            <div
              class="flex flex-col gap-4 mb-4 mt-6"
            >
              <ul class="flex flex-col gap-4 text-xs text-gray-900">
                <li
                  v-for="{ includes, value, integrations } in plan.features"
                  :key="value"
                >
                  <span class="flex items-start gap-3 leading-5">
                    <i
                      class="text-lg"
                      :class="{
                        'ri-checkbox-circle-fill': includes,
                        'ri-close-circle-fill': !includes,
                      }"
                    />
                    <span>{{ value }}</span>
                  </span>
                  <div v-if="integrations?.length" class="flex flex-wrap gap-2 mt-4 ml-8">
                    <div
                      v-for="integration in integrations"
                      :key="integration"
                    >
                      <el-tooltip
                        v-if="CrowdIntegrations.getConfig(integration)"
                        placement="top"
                        :content="CrowdIntegrations.getConfig(integration).name"
                      >
                        <div
                          class="bg-white rounded-md shadow w-12 h-12 flex items-center justify-center"
                        >
                          <img
                            :alt="CrowdIntegrations.getConfig(integration).name"
                            :src="CrowdIntegrations.getConfig(integration).image"
                            class="w-5"
                          />
                        </div>
                      </el-tooltip>
                    </div>
                  </div>
                </li>
              </ul>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
  <app-dialog
    v-model="isCalDialogOpen"
    size="2extra-large"
  >
    <template #content>
      <div id="embbeded-script" class="w-full px-3 pb-3 min-h-20" />
    </template>
  </app-dialog>
</template>

<script setup>
import {
  computed, defineProps, onMounted, ref,
} from 'vue';
import { useStore } from 'vuex';
import config from '@/config';
import Plans from '@/security/plans';
import { mapActions } from '@/shared/vuex/vuex.helpers';
import { CrowdIntegrations } from '@/integrations/integrations-config';
import { isTrialExpired } from '@/utils/date';
import { FeatureFlag, FEATURE_FLAGS } from '@/utils/featureFlag';
import { plans } from '../settings-pricing-plans';

const hostedPlans = Plans.values;
const communityPlans = Plans.communityValues;

const { isCommunityVersion } = config;
const isCommunitPremiumVersion = config.communityPremium === 'true';

const { doRefreshCurrentUser } = mapActions('auth');

const store = useStore();

const isCalDialogOpen = ref(false);
const monthlyPayment = ref(config.isMonthlyPayments);

const props = defineProps({
  customerPortalLink: {
    type: String,
    default: null,
  },
});

const currentTenant = computed(
  () => store.getters['auth/currentTenant'],
);

const plansList = computed(() => {
  if (isCommunityVersion) {
    return plans.community;
  }

  return plans.hosted;
});

const nonCCTrial = computed(() => FeatureFlag.isFlagEnabled(
  FEATURE_FLAGS.nonCCTrial,
));

const activePlan = computed(() => {
  // Community Versions
  if (isCommunityVersion) {
    return isCommunitPremiumVersion
      ? communityPlans.custom
      : communityPlans.community;
  }
  const emptyPlan = currentTenant.value.plan ? Plans.values.trialExpired : Plans.values.none
  // Crowd Hosted Versions
  return isTrialExpired(currentTenant.value) ? emptyPlan : currentTenant.value.plan;
});

onMounted(() => {
  this.$posthog?.capture('Plans List Viewed');
  doRefreshCurrentUser({});
});

const getBadge = (plan) => {
  if (plan === hostedPlans.business && [hostedPlans.starter, hostedPlans.eagleEye].includes(activePlan.value)) {
    // Recommended plan
    return {
      class: 'text-brand-600 bg-brand-50',
      content: 'Recommended',
    };
  } if (plan === activePlan.value) {
    // Active plans
    return {
      class: 'text-white bg-brand-500',
      content: 'Current plan',
    };
  }

  return null;
};

const displayCalDialog = () => {
  isCalDialogOpen.value = true;
};

const handleOnCtaClick = ({ key, ctaAction }) => {
  // Send an event with plan request
  window.analytics?.track('Change Plan Request', {
    tenantId: currentTenant.value.id,
    tenantName: currentTenant.value.name,
    requestedPlan: key,
  });

  ctaAction[activePlan.value ?? Plans.values.none]({
    displayCalDialog,
    monthlyPayment: monthlyPayment.value,
    nonCCTrial: nonCCTrial.value,
    customerPortalLink: props.customerPortalLink,
  });
};
</script>

<script>
export default {
  name: 'AppPlansList',
};
</script>

<style lang="scss">
.pricing-plan {
  @apply flex flex-col flex-1 rounded-lg bg-white border border-solid border-gray-100 p-5 grow justify-between shadow;

  &.active {
    @apply border-gray-50 bg-gray-50 shadow-none;
  }
}
</style>
